Public Class frmRoman1

    Private Sub btnConvert_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConvert.Click

        If Val(txtNumber.Text) < 1 Or Val(txtNumber.Text) > 3999 Then
            MsgBox("Number out of range. Please enter a number between 1 and 3999.", _
                   MsgBoxStyle.Exclamation, _
                   "Roman Numerals")
            txtNumber.Focus()
            Exit Sub
        End If

        lblRoman.Text = ConvertToRoman((txtNumber.Text))

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    Private Sub txtNumber_GotFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtNumber.GotFocus
        txtNumber.SelectAll()
    End Sub

    Private Sub txtNumber_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtNumber.KeyPress
        e.Handled = Not (Char.IsDigit(e.KeyChar) Or Asc(e.KeyChar) < 32)
    End Sub

    Private Sub txtNumber_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtNumber.TextChanged
        lblRoman.Text = ""
    End Sub

    Private Function ConvertToRoman(ByRef pstrDecimalNumber As String) As String

        Const strPOS_VAL As String = "IXCM"
        Const strFIVE_VAL As String = "VLD"

        Dim strRoman As String
        Dim strCurrRomanPos As String
        Dim strLetter1 As String
        Dim strLetter2 As String
        Dim intCurrPos As Short
        Dim intDigit As Short
        Dim intDigitPos As Short

        intCurrPos = 1
        strRoman = ""

        For intDigitPos = Len(pstrDecimalNumber) To 1 Step -1
            intDigit = Val(Mid(pstrDecimalNumber, intDigitPos, 1))
            strCurrRomanPos = Mid(strPOS_VAL, intCurrPos, 1)
            Select Case intDigit
                Case 9
                    strLetter1 = strCurrRomanPos
                    strLetter2 = Mid(strPOS_VAL, intCurrPos + 1, 1)
                Case Is > 4
                    strLetter1 = Mid(strFIVE_VAL, intCurrPos, 1)
                    strLetter2 = New String(strCurrRomanPos, intDigit - 5)
                Case 4
                    strLetter1 = strCurrRomanPos
                    strLetter2 = Mid(strFIVE_VAL, intCurrPos, 1)
                Case Else
                    strLetter1 = New String(strCurrRomanPos, intDigit)
                    strLetter2 = ""
            End Select
            strRoman = strLetter1 & strLetter2 & strRoman
            intCurrPos = intCurrPos + 1
        Next

        ConvertToRoman = strRoman

    End Function

End Class
